"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Provider = void 0;
var React = require("react");
var actionTypes_1 = require("../utils/actionTypes");
var createAction_1 = require("../createAction");
var useGetter_1 = require("../hooks/useGetter");
function Provider(_a) {
    var children = _a.children, Context = _a.Context;
    var root = React.useContext(Context);
    var _b = __read(React.useReducer(root.reducer, root.state), 2), state = _b[0], reducerDispatch = _b[1];
    var getState = useGetter_1.useGetter(state);
    var dispatch = React.useCallback(function wrappedDispatch(action) {
        reducerDispatch(action);
        return action;
    }, [reducerDispatch]);
    var enhanced = React.useMemo(function () {
        var _a;
        var enhancer = root.enhancer, value = __rest(root, ["enhancer"]);
        Object.assign(value, { dispatch: dispatch, getState: getState });
        return (_a = enhancer === null || enhancer === void 0 ? void 0 : enhancer(value)) !== null && _a !== void 0 ? _a : value;
    }, [dispatch, getState, root]);
    React.useEffect(function initialiseContext() {
        enhanced.dispatch(createAction_1.createAction(actionTypes_1.ActionTypes.INIT)());
    }, [enhanced]);
    var value = React.useMemo(function () { return (__assign(__assign({}, enhanced), { state: state })); }, [enhanced, state]);
    return React.createElement(Context.Provider, { value: value }, children);
}
exports.Provider = Provider;
