"use strict";
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createDuck = void 0;
var createReducer_1 = require("./createReducer");
var createAction_1 = require("./createAction");
var getEntries_1 = require("./utils/getEntries");
function getNS(name, actionType) {
    return name + "/" + actionType;
}
function reverseMap(map) {
    var e_1, _a;
    if (!map)
        return {};
    var reversedMap = {};
    try {
        for (var _b = __values(getEntries_1.getEntries(map)), _c = _b.next(); !_c.done; _c = _b.next()) {
            var _d = __read(_c.value, 2), mappedActionType = _d[0], actionType = _d[1];
            if (!reversedMap[actionType]) {
                reversedMap[actionType] = new Set();
            }
            reversedMap[actionType].add(mappedActionType);
        }
    }
    catch (e_1_1) { e_1 = { error: e_1_1 }; }
    finally {
        try {
            if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
        }
        finally { if (e_1) throw e_1.error; }
    }
    return reversedMap;
}
function createDuck(_a) {
    var e_2, _b, e_3, _c;
    var name = _a.name, initialState = _a.initialState, reducers = _a.reducers, selectors = _a.selectors, actionMapping = _a.actionMapping;
    var mappedActionTypes = reverseMap(actionMapping);
    var actions = {};
    var namedspacedReducers = {};
    try {
        for (var _d = __values(getEntries_1.getEntries(reducers)), _e = _d.next(); !_e.done; _e = _d.next()) {
            var _f = __read(_e.value, 2), actionType = _f[0], reducer_1 = _f[1];
            var namespacedActionType = getNS(name, actionType);
            actions[actionType] = createAction_1.createAction(namespacedActionType);
            var mappedReducer = reducer_1;
            namedspacedReducers[namespacedActionType] = mappedReducer;
            if (mappedActionTypes[actionType]) {
                try {
                    for (var _g = (e_3 = void 0, __values(mappedActionTypes[actionType])), _h = _g.next(); !_h.done; _h = _g.next()) {
                        var mappedActionType = _h.value;
                        namedspacedReducers[mappedActionType] = mappedReducer;
                    }
                }
                catch (e_3_1) { e_3 = { error: e_3_1 }; }
                finally {
                    try {
                        if (_h && !_h.done && (_c = _g.return)) _c.call(_g);
                    }
                    finally { if (e_3) throw e_3.error; }
                }
            }
        }
    }
    catch (e_2_1) { e_2 = { error: e_2_1 }; }
    finally {
        try {
            if (_e && !_e.done && (_b = _d.return)) _b.call(_d);
        }
        finally { if (e_2) throw e_2.error; }
    }
    var reducer = createReducer_1.createReducer(initialState, namedspacedReducers);
    return {
        actions: actions,
        initialState: initialState,
        name: name,
        reducer: reducer,
        selectors: selectors,
    };
}
exports.createDuck = createDuck;
